var BootstrapDirective = (function () {
    function BootstrapDirective(renderer, elementRef, initClasses, allowedTags) {
        if (allowedTags === void 0) { allowedTags = ['DIV']; }
        this.renderer = renderer;
        this.elementRef = elementRef;
        this.initClasses = initClasses;
        this.allowedTags = allowedTags;
    }
    BootstrapDirective.prototype.ngOnInit = function () {
        for (var _i = 0, _a = this.initClasses; _i < _a.length; _i++) {
            var cssClass = _a[_i];
            this.addClass(cssClass);
        }
        if (this.allowedTags.indexOf(this.elementRef.nativeElement.tagName) === -1) {
            throw new Error("this directive can not used on '" + this.elementRef.nativeElement.tagName + "' elements");
        }
    };
    BootstrapDirective.prototype.addClass = function (cssClass) {
        this.renderer.addClass(this.elementRef.nativeElement, cssClass);
    };
    BootstrapDirective.prototype.removeClass = function (cssClass) {
        this.renderer.removeClass(this.elementRef.nativeElement, cssClass);
    };
    BootstrapDirective.prototype.setAttribute = function (attribute, value) {
        this.renderer.setAttribute(this.elementRef.nativeElement, attribute, value);
    };
    BootstrapDirective.prototype.removeAttribute = function (attribute) {
        this.renderer.removeAttribute(this.elementRef.nativeElement, attribute);
    };
    BootstrapDirective.prototype.setStyle = function (style, value) {
        this.renderer.setStyle(this.elementRef.nativeElement, style, value);
    };
    BootstrapDirective.prototype.setProperty = function (name, value) {
        this.renderer.setProperty(this.elementRef.nativeElement, name, value);
    };
    BootstrapDirective.prototype.setValue = function (value) {
        this.renderer.setValue(this.elementRef.nativeElement, value);
    };
    return BootstrapDirective;
}());
export { BootstrapDirective };
//# sourceMappingURL=bootstrap.directive.js.map