var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Directive, ElementRef, Input, Renderer2 } from '@angular/core';
import { BootstrapDisabledDirective } from '../bootstrap/bootstrap-disabled.directive';
import { BootstrapDirective } from '../bootstrap/bootstrap.directive';
import { ApplyMixins } from '../helper/applyMixins';
var FormControlDirective = (function (_super) {
    __extends(FormControlDirective, _super);
    function FormControlDirective(r, er) {
        var _this = _super.call(this, r, er, ['form-control'], ['INPUT', 'SELECT']) || this;
        _this._size = null;
        return _this;
    }
    Object.defineProperty(FormControlDirective.prototype, "readonly", {
        set: function (value) {
            value ? this.setAttribute('readonly', '') : this.removeAttribute('readonly');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormControlDirective.prototype, "size", {
        set: function (value) {
            if (this._size !== null) {
                this.removeClass("input-" + this._size);
            }
            this._size = value;
            if (this._size !== null) {
                this.addClass("input-" + this._size);
            }
        },
        enumerable: true,
        configurable: true
    });
    FormControlDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        var type = this.elementRef.nativeElement.getAttribute('type');
        if (FormControlDirective.SUPPORTED_TYPES.indexOf(type) === -1) {
            throw new Error("the input type '" + type + "' is not supported");
        }
    };
    return FormControlDirective;
}(BootstrapDirective));
export { FormControlDirective };
FormControlDirective.SUPPORTED_TYPES = [
    'text',
    'password',
    'datetime',
    'datetime-local',
    'date',
    'month',
    'time',
    'week',
    'number',
    'email',
    'url',
    'search',
    'tel',
    'color',
];
FormControlDirective.decorators = [
    { type: Directive, args: [{ selector: '[upe-form-control]' },] },
];
/** @nocollapse */
FormControlDirective.ctorParameters = function () { return [
    { type: Renderer2, },
    { type: ElementRef, },
]; };
FormControlDirective.propDecorators = {
    'readonly': [{ type: Input },],
    'size': [{ type: Input },],
    'disabled': [{ type: Input },],
};
ApplyMixins(FormControlDirective, [BootstrapDisabledDirective]);
//# sourceMappingURL=form-control.directive.js.map