export function ApplyMixins(derivedCtor, baseCtors) {
    for (var _i = 0, baseCtors_1 = baseCtors; _i < baseCtors_1.length; _i++) {
        var baseCtor = baseCtors_1[_i];
        var propertyNames = Object.getOwnPropertyNames(baseCtor.prototype);
        for (var _a = 0, _b = propertyNames.filter(function (pn) { return pn !== 'constructor'; }); _a < _b.length; _a++) {
            var propertyName = _b[_a];
            var descriptor = Object.getOwnPropertyDescriptor(baseCtor.prototype, propertyName);
            var property = baseCtor.prototype[propertyName];
            if (!property && descriptor) {
                Object.defineProperty(derivedCtor.prototype, propertyName, {
                    get: descriptor.get,
                    set: descriptor.set,
                    enumerable: descriptor.enumerable,
                    configurable: descriptor.configurable,
                });
            }
            else {
                derivedCtor.prototype[propertyName] = property;
            }
        }
    }
}
//# sourceMappingURL=applyMixins.js.map