(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core'], factory) :
	(factory((global['ngx-module'] = {}),global.core));
}(this, (function (exports,core) { 'use strict';

function __extends(d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}

var BootstrapDirective = (function () {
    function BootstrapDirective(renderer, elementRef, initClasses, allowedTags) {
        if (allowedTags === void 0) { allowedTags = ['DIV']; }
        this.renderer = renderer;
        this.elementRef = elementRef;
        this.initClasses = initClasses;
        this.allowedTags = allowedTags;
    }
    BootstrapDirective.prototype.ngOnInit = function () {
        for (var _i = 0, _a = this.initClasses; _i < _a.length; _i++) {
            var cssClass = _a[_i];
            this.addClass(cssClass);
        }
        if (this.allowedTags.indexOf(this.elementRef.nativeElement.tagName) === -1) {
            throw new Error("this directive can not used on '" + this.elementRef.nativeElement.tagName + "' elements");
        }
    };
    BootstrapDirective.prototype.addClass = function (cssClass) {
        this.renderer.addClass(this.elementRef.nativeElement, cssClass);
    };
    BootstrapDirective.prototype.removeClass = function (cssClass) {
        this.renderer.removeClass(this.elementRef.nativeElement, cssClass);
    };
    BootstrapDirective.prototype.setAttribute = function (attribute, value) {
        this.renderer.setAttribute(this.elementRef.nativeElement, attribute, value);
    };
    BootstrapDirective.prototype.removeAttribute = function (attribute) {
        this.renderer.removeAttribute(this.elementRef.nativeElement, attribute);
    };
    BootstrapDirective.prototype.setStyle = function (style, value) {
        this.renderer.setStyle(this.elementRef.nativeElement, style, value);
    };
    BootstrapDirective.prototype.setProperty = function (name, value) {
        this.renderer.setProperty(this.elementRef.nativeElement, name, value);
    };
    BootstrapDirective.prototype.setValue = function (value) {
        this.renderer.setValue(this.elementRef.nativeElement, value);
    };
    return BootstrapDirective;
}());

var BootstrapSizeDirective = (function (_super) {
    __extends(BootstrapSizeDirective, _super);
    function BootstrapSizeDirective(r, er, ic, at, defaultSize) {
        var _this = this;
        if (defaultSize) {
            ic.push(ic[0] + "-" + defaultSize);
        }
        _this = _super.call(this, r, er, ic, at) || this;
        _this._baseName = ic[0];
        _this._size = defaultSize ? defaultSize : null;
        return _this;
    }
    Object.defineProperty(BootstrapSizeDirective.prototype, "size", {
        set: function (value) {
            if (this._size !== null) {
                this.removeClass(this._baseName + "-" + this._size);
            }
            this._size = value;
            if (value !== null) {
                this.addClass(this._baseName + "-" + this._size);
            }
        },
        enumerable: true,
        configurable: true
    });
    return BootstrapSizeDirective;
}(BootstrapDirective));
__decorate([
    core.Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], BootstrapSizeDirective.prototype, "size", null);

exports.BtnGroupDirective = (function (_super) {
    __extends(BtnGroupDirective, _super);
    function BtnGroupDirective(r, er) {
        return _super.call(this, r, er, ['btn-group']) || this;
    }
    BtnGroupDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.setAttribute('role', 'group');
    };
    return BtnGroupDirective;
}(BootstrapSizeDirective));
exports.BtnGroupDirective = __decorate([
    core.Directive({ selector: '[upe-btn-group]' }),
    __metadata("design:paramtypes", [typeof (_a = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a || Object, typeof (_b = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b || Object])
], exports.BtnGroupDirective);
var _a;
var _b;

exports.BtnGroupJustifiedDirective = (function (_super) {
    __extends(BtnGroupJustifiedDirective, _super);
    function BtnGroupJustifiedDirective(r, er) {
        return _super.call(this, r, er, ['btn-group-justified']) || this;
    }
    BtnGroupJustifiedDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.setAttribute('role', 'group');
    };
    return BtnGroupJustifiedDirective;
}(BootstrapDirective));
exports.BtnGroupJustifiedDirective = __decorate([
    core.Directive({ selector: '[upe-btn-group-justified]' }),
    __metadata("design:paramtypes", [typeof (_a$1 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$1 || Object, typeof (_b$1 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$1 || Object])
], exports.BtnGroupJustifiedDirective);
var _a$1;
var _b$1;

exports.BtnGroupVerticalDirective = (function (_super) {
    __extends(BtnGroupVerticalDirective, _super);
    function BtnGroupVerticalDirective(r, er) {
        return _super.call(this, r, er, ['btn-group-vertical']) || this;
    }
    BtnGroupVerticalDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.setAttribute('role', 'group');
    };
    return BtnGroupVerticalDirective;
}(BootstrapDirective));
exports.BtnGroupVerticalDirective = __decorate([
    core.Directive({ selector: '[upe-btn-group-vertical]' }),
    __metadata("design:paramtypes", [typeof (_a$2 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$2 || Object, typeof (_b$2 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$2 || Object])
], exports.BtnGroupVerticalDirective);
var _a$2;
var _b$2;

exports.BtnToolbarDirective = (function (_super) {
    __extends(BtnToolbarDirective, _super);
    function BtnToolbarDirective(r, er) {
        return _super.call(this, r, er, ['btn-toolbar']) || this;
    }
    BtnToolbarDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.setAttribute('role', 'toolbar');
    };
    return BtnToolbarDirective;
}(BootstrapDirective));
exports.BtnToolbarDirective = __decorate([
    core.Directive({ selector: '[upe-btn-toolbar]' }),
    __metadata("design:paramtypes", [typeof (_a$3 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$3 || Object, typeof (_b$3 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$3 || Object])
], exports.BtnToolbarDirective);
var _a$3;
var _b$3;

exports.BtnGroupDirectivesModule = (function () {
    function BtnGroupDirectivesModule() {
    }
    return BtnGroupDirectivesModule;
}());
exports.BtnGroupDirectivesModule = __decorate([
    core.NgModule({
        imports: [],
        exports: [
            exports.BtnGroupDirective,
            exports.BtnGroupJustifiedDirective,
            exports.BtnGroupVerticalDirective,
            exports.BtnToolbarDirective,
        ],
        declarations: [
            exports.BtnGroupDirective,
            exports.BtnGroupJustifiedDirective,
            exports.BtnGroupVerticalDirective,
            exports.BtnToolbarDirective,
        ],
        providers: [],
    })
], exports.BtnGroupDirectivesModule);

var BootstrapActiveDirective = (function (_super) {
    __extends(BootstrapActiveDirective, _super);
    function BootstrapActiveDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(BootstrapActiveDirective.prototype, "active", {
        set: function (value) {
            value ? this.addClass('active') : this.removeClass('active');
        },
        enumerable: true,
        configurable: true
    });
    return BootstrapActiveDirective;
}(BootstrapDirective));

var BootstrapDisabledDirective = (function (_super) {
    __extends(BootstrapDisabledDirective, _super);
    function BootstrapDisabledDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(BootstrapDisabledDirective.prototype, "disabled", {
        set: function (value) {
            value ? this.addClass('disabled') : this.removeClass('disabled');
            value ? this.setAttribute('disabled', '') : this.removeAttribute('disabled');
        },
        enumerable: true,
        configurable: true
    });
    return BootstrapDisabledDirective;
}(BootstrapDirective));

var BootstrapTypeDirective = (function (_super) {
    __extends(BootstrapTypeDirective, _super);
    function BootstrapTypeDirective(r, er, ic, at, defaultType) {
        var _this = this;
        if (defaultType) {
            ic.push(ic[0] + "-" + defaultType);
        }
        _this = _super.call(this, r, er, ic, at) || this;
        _this._baseName = ic[0];
        _this._classType = defaultType ? defaultType : null;
        return _this;
    }
    Object.defineProperty(BootstrapTypeDirective.prototype, "classType", {
        set: function (value) {
            if (this._classType !== null) {
                this.removeClass(this._baseName + "-" + this._classType);
            }
            this._classType = value;
            this.addClass(this._baseName + "-" + this._classType);
        },
        enumerable: true,
        configurable: true
    });
    return BootstrapTypeDirective;
}(BootstrapDirective));
__decorate([
    core.Input('class-type'),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], BootstrapTypeDirective.prototype, "classType", null);

function ApplyMixins(derivedCtor, baseCtors) {
    for (var _i = 0, baseCtors_1 = baseCtors; _i < baseCtors_1.length; _i++) {
        var baseCtor = baseCtors_1[_i];
        var propertyNames = Object.getOwnPropertyNames(baseCtor.prototype);
        for (var _a = 0, _b = propertyNames.filter(function (pn) { return pn !== 'constructor'; }); _a < _b.length; _a++) {
            var propertyName = _b[_a];
            var descriptor = Object.getOwnPropertyDescriptor(baseCtor.prototype, propertyName);
            var property = baseCtor.prototype[propertyName];
            if (!property && descriptor) {
                Object.defineProperty(derivedCtor.prototype, propertyName, {
                    get: descriptor.get,
                    set: descriptor.set,
                    enumerable: descriptor.enumerable,
                    configurable: descriptor.configurable,
                });
            }
            else {
                derivedCtor.prototype[propertyName] = property;
            }
        }
    }
}

exports.BtnDirective = (function (_super) {
    __extends(BtnDirective, _super);
    function BtnDirective(r, er) {
        var _this = _super.call(this, r, er, ['btn'], ['BUTTON', 'INPUT', 'A'], 'default') || this;
        _this._type = 'button';
        return _this;
    }
    Object.defineProperty(BtnDirective.prototype, "type", {
        set: function (value) {
            this.setAttribute('type', value);
            this._type = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BtnDirective.prototype, "block", {
        set: function (value) {
            value ? this.addClass('btn-block') : this.removeClass('btn-block');
        },
        enumerable: true,
        configurable: true
    });
    BtnDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.setAttribute('role', 'button');
        this.type = this._type;
    };
    return BtnDirective;
}(BootstrapTypeDirective));
__decorate([
    core.Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], exports.BtnDirective.prototype, "type", null);
__decorate([
    core.Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], exports.BtnDirective.prototype, "block", null);
__decorate([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.BtnDirective.prototype, "active", void 0);
__decorate([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.BtnDirective.prototype, "disabled", void 0);
exports.BtnDirective = __decorate([
    core.Directive({ selector: '[upe-btn]' }),
    __metadata("design:paramtypes", [typeof (_a$4 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$4 || Object, typeof (_b$4 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$4 || Object])
], exports.BtnDirective);
ApplyMixins(exports.BtnDirective, [BootstrapActiveDirective, BootstrapDisabledDirective]);
var _a$4;
var _b$4;

exports.ButtonDirectivesModule = (function () {
    function ButtonDirectivesModule() {
    }
    return ButtonDirectivesModule;
}());
exports.ButtonDirectivesModule = __decorate([
    core.NgModule({
        imports: [],
        exports: [
            exports.BtnDirective,
        ],
        declarations: [
            exports.BtnDirective,
        ],
        providers: [],
    })
], exports.ButtonDirectivesModule);

exports.CheckboxDirective = (function (_super) {
    __extends(CheckboxDirective, _super);
    function CheckboxDirective(r, er) {
        return _super.call(this, r, er, ['checkbox']) || this;
    }
    return CheckboxDirective;
}(BootstrapDirective));
__decorate([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.CheckboxDirective.prototype, "disabled", void 0);
exports.CheckboxDirective = __decorate([
    core.Directive({ selector: '[upe-checkbox]' }),
    __metadata("design:paramtypes", [typeof (_a$5 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$5 || Object, typeof (_b$5 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$5 || Object])
], exports.CheckboxDirective);
ApplyMixins(exports.CheckboxDirective, [BootstrapDisabledDirective]);
var _a$5;
var _b$5;

exports.CheckboxInlineDirective = (function (_super) {
    __extends(CheckboxInlineDirective, _super);
    function CheckboxInlineDirective(r, er) {
        return _super.call(this, r, er, ['checkbox-inline'], ['LABEL']) || this;
    }
    return CheckboxInlineDirective;
}(BootstrapDirective));
__decorate([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.CheckboxInlineDirective.prototype, "disabled", void 0);
exports.CheckboxInlineDirective = __decorate([
    core.Directive({ selector: '[upe-checkbox-inline]' }),
    __metadata("design:paramtypes", [typeof (_a$6 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$6 || Object, typeof (_b$6 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$6 || Object])
], exports.CheckboxInlineDirective);
ApplyMixins(exports.CheckboxInlineDirective, [BootstrapDisabledDirective]);
var _a$6;
var _b$6;

exports.ControlLabelDirective = (function (_super) {
    __extends(ControlLabelDirective, _super);
    function ControlLabelDirective(r, er) {
        return _super.call(this, r, er, ['control-label'], ['LABEL']) || this;
    }
    return ControlLabelDirective;
}(BootstrapDirective));
exports.ControlLabelDirective = __decorate([
    core.Directive({ selector: '[upe-control-label]' }),
    __metadata("design:paramtypes", [typeof (_a$7 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$7 || Object, typeof (_b$7 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$7 || Object])
], exports.ControlLabelDirective);
var _a$7;
var _b$7;

exports.FormControlDirective = FormControlDirective_1 = (function (_super) {
    __extends(FormControlDirective, _super);
    function FormControlDirective(r, er) {
        var _this = _super.call(this, r, er, ['form-control'], ['INPUT', 'SELECT']) || this;
        _this._size = null;
        return _this;
    }
    Object.defineProperty(FormControlDirective.prototype, "readonly", {
        set: function (value) {
            value ? this.setAttribute('readonly', '') : this.removeAttribute('readonly');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormControlDirective.prototype, "size", {
        set: function (value) {
            if (this._size !== null) {
                this.removeClass("input-" + this._size);
            }
            this._size = value;
            if (this._size !== null) {
                this.addClass("input-" + this._size);
            }
        },
        enumerable: true,
        configurable: true
    });
    FormControlDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        var type = this.elementRef.nativeElement.getAttribute('type');
        if (FormControlDirective_1.SUPPORTED_TYPES.indexOf(type) === -1) {
            throw new Error("the input type '" + type + "' is not supported");
        }
    };
    return FormControlDirective;
}(BootstrapDirective));
exports.FormControlDirective.SUPPORTED_TYPES = [
    'text',
    'password',
    'datetime',
    'datetime-local',
    'date',
    'month',
    'time',
    'week',
    'number',
    'email',
    'url',
    'search',
    'tel',
    'color',
];
__decorate([
    core.Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], exports.FormControlDirective.prototype, "readonly", null);
__decorate([
    core.Input(),
    __metadata("design:type", typeof (_a$8 = typeof Size !== "undefined" && Size) === "function" && _a$8 || Object),
    __metadata("design:paramtypes", [typeof (_b$8 = typeof Size !== "undefined" && Size) === "function" && _b$8 || Object])
], exports.FormControlDirective.prototype, "size", null);
__decorate([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.FormControlDirective.prototype, "disabled", void 0);
exports.FormControlDirective = FormControlDirective_1 = __decorate([
    core.Directive({ selector: '[upe-form-control]' }),
    __metadata("design:paramtypes", [typeof (_c = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _c || Object, typeof (_d = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _d || Object])
], exports.FormControlDirective);
ApplyMixins(exports.FormControlDirective, [BootstrapDisabledDirective]);
var FormControlDirective_1;
var _a$8;
var _b$8;
var _c;
var _d;

exports.FormControlStaticDirective = (function (_super) {
    __extends(FormControlStaticDirective, _super);
    function FormControlStaticDirective(r, er) {
        return _super.call(this, r, er, ['form-control-static'], ['P']) || this;
    }
    return FormControlStaticDirective;
}(BootstrapDirective));
exports.FormControlStaticDirective = __decorate([
    core.Directive({ selector: '[upe-form-control-static]' }),
    __metadata("design:paramtypes", [typeof (_a$9 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$9 || Object, typeof (_b$9 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$9 || Object])
], exports.FormControlStaticDirective);
var _a$9;
var _b$9;

exports.FormGroupDirective = (function (_super) {
    __extends(FormGroupDirective, _super);
    function FormGroupDirective(r, er) {
        var _this = _super.call(this, r, er, ['form-group']) || this;
        _this._validationState = null;
        return _this;
    }
    Object.defineProperty(FormGroupDirective.prototype, "validationState", {
        set: function (value) {
            if (this._validationState !== null) {
                this.removeClass("has-" + this._validationState);
            }
            this._validationState = value;
            if (this._validationState !== null) {
                this.addClass("has-" + this._validationState);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormGroupDirective.prototype, "hasFeedback", {
        set: function (value) {
            value ? this.addClass('has-feedback') : this.removeClass('has-feedback');
        },
        enumerable: true,
        configurable: true
    });
    return FormGroupDirective;
}(BootstrapSizeDirective));
__decorate([
    core.Input(),
    __metadata("design:type", typeof (_a$10 = typeof ValidationState !== "undefined" && ValidationState) === "function" && _a$10 || Object),
    __metadata("design:paramtypes", [typeof (_b$10 = typeof ValidationState !== "undefined" && ValidationState) === "function" && _b$10 || Object])
], exports.FormGroupDirective.prototype, "validationState", null);
__decorate([
    core.Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], exports.FormGroupDirective.prototype, "hasFeedback", null);
exports.FormGroupDirective = __decorate([
    core.Directive({ selector: '[upe-form-group]' }),
    __metadata("design:paramtypes", [typeof (_c$1 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _c$1 || Object, typeof (_d$1 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _d$1 || Object])
], exports.FormGroupDirective);
var _a$10;
var _b$10;
var _c$1;
var _d$1;

exports.FormHorizontalDirective = (function (_super) {
    __extends(FormHorizontalDirective, _super);
    function FormHorizontalDirective(r, er) {
        return _super.call(this, r, er, ['form-horizontal'], ['FORM']) || this;
    }
    return FormHorizontalDirective;
}(BootstrapDirective));
exports.FormHorizontalDirective = __decorate([
    core.Directive({ selector: '[upe-form-horizontal]' }),
    __metadata("design:paramtypes", [typeof (_a$11 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$11 || Object, typeof (_b$11 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$11 || Object])
], exports.FormHorizontalDirective);
var _a$11;
var _b$11;

exports.FormInlineDirective = (function (_super) {
    __extends(FormInlineDirective, _super);
    function FormInlineDirective(r, er) {
        return _super.call(this, r, er, ['form-inline'], ['FORM']) || this;
    }
    return FormInlineDirective;
}(BootstrapDirective));
exports.FormInlineDirective = __decorate([
    core.Directive({ selector: '[upe-form-inline]' }),
    __metadata("design:paramtypes", [typeof (_a$12 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$12 || Object, typeof (_b$12 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$12 || Object])
], exports.FormInlineDirective);
var _a$12;
var _b$12;

exports.HelpBlockDirective = (function (_super) {
    __extends(HelpBlockDirective, _super);
    function HelpBlockDirective(r, er) {
        return _super.call(this, r, er, ['help-block'], ['SPAN']) || this;
    }
    return HelpBlockDirective;
}(BootstrapDirective));
exports.HelpBlockDirective = __decorate([
    core.Directive({ selector: '[upe-help-block]' }),
    __metadata("design:paramtypes", [typeof (_a$13 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$13 || Object, typeof (_b$13 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$13 || Object])
], exports.HelpBlockDirective);
var _a$13;
var _b$13;

exports.RadioInlineDirective = (function (_super) {
    __extends(RadioInlineDirective, _super);
    function RadioInlineDirective(r, er) {
        return _super.call(this, r, er, ['radio-inline'], ['LABEL']) || this;
    }
    return RadioInlineDirective;
}(BootstrapDirective));
__decorate([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.RadioInlineDirective.prototype, "disabled", void 0);
exports.RadioInlineDirective = __decorate([
    core.Directive({ selector: '[upe-radio-inline]' }),
    __metadata("design:paramtypes", [typeof (_a$14 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$14 || Object, typeof (_b$14 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$14 || Object])
], exports.RadioInlineDirective);
ApplyMixins(exports.RadioInlineDirective, [BootstrapDisabledDirective]);
var _a$14;
var _b$14;

exports.RadioDirective = (function (_super) {
    __extends(RadioDirective, _super);
    function RadioDirective(r, er) {
        return _super.call(this, r, er, ['radio']) || this;
    }
    return RadioDirective;
}(BootstrapDirective));
__decorate([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.RadioDirective.prototype, "disabled", void 0);
exports.RadioDirective = __decorate([
    core.Directive({ selector: '[upe-radio]' }),
    __metadata("design:paramtypes", [typeof (_a$15 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$15 || Object, typeof (_b$15 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$15 || Object])
], exports.RadioDirective);
ApplyMixins(exports.RadioDirective, [BootstrapDisabledDirective]);
var _a$15;
var _b$15;

exports.FormDirectivesModule = (function () {
    function FormDirectivesModule() {
    }
    return FormDirectivesModule;
}());
exports.FormDirectivesModule = __decorate([
    core.NgModule({
        imports: [],
        exports: [
            exports.CheckboxInlineDirective,
            exports.CheckboxDirective,
            exports.ControlLabelDirective,
            exports.FormControlDirective,
            exports.FormControlStaticDirective,
            exports.FormGroupDirective,
            exports.FormHorizontalDirective,
            exports.FormInlineDirective,
            exports.HelpBlockDirective,
            exports.RadioDirective,
            exports.RadioInlineDirective,
        ],
        declarations: [
            exports.CheckboxInlineDirective,
            exports.CheckboxDirective,
            exports.ControlLabelDirective,
            exports.FormControlDirective,
            exports.FormControlStaticDirective,
            exports.FormGroupDirective,
            exports.FormHorizontalDirective,
            exports.FormInlineDirective,
            exports.HelpBlockDirective,
            exports.RadioDirective,
            exports.RadioInlineDirective,
        ],
        providers: [],
    })
], exports.FormDirectivesModule);

exports.InputGroupAddonDirective = (function (_super) {
    __extends(InputGroupAddonDirective, _super);
    function InputGroupAddonDirective(r, er) {
        return _super.call(this, r, er, ['input-group-addon'], ['SPAN']) || this;
    }
    return InputGroupAddonDirective;
}(BootstrapDirective));
exports.InputGroupAddonDirective = __decorate([
    core.Directive({ selector: '[upe-input-group-addon]' }),
    __metadata("design:paramtypes", [typeof (_a$16 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$16 || Object, typeof (_b$16 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$16 || Object])
], exports.InputGroupAddonDirective);
var _a$16;
var _b$16;

exports.InputGroupBtnDirective = (function (_super) {
    __extends(InputGroupBtnDirective, _super);
    function InputGroupBtnDirective(r, er) {
        return _super.call(this, r, er, ['input-group-btn'], ['SPAN']) || this;
    }
    return InputGroupBtnDirective;
}(BootstrapDirective));
exports.InputGroupBtnDirective = __decorate([
    core.Directive({ selector: '[upe-input-group-btn]' }),
    __metadata("design:paramtypes", [typeof (_a$17 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$17 || Object, typeof (_b$17 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$17 || Object])
], exports.InputGroupBtnDirective);
var _a$17;
var _b$17;

exports.InputGroupDirective = (function (_super) {
    __extends(InputGroupDirective, _super);
    function InputGroupDirective(r, er) {
        return _super.call(this, r, er, ['input-group']) || this;
    }
    return InputGroupDirective;
}(BootstrapSizeDirective));
exports.InputGroupDirective = __decorate([
    core.Directive({ selector: '[upe-input-group]' }),
    __metadata("design:paramtypes", [typeof (_a$18 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$18 || Object, typeof (_b$18 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$18 || Object])
], exports.InputGroupDirective);
var _a$18;
var _b$18;

exports.InputGroupDirectivesModule = (function () {
    function InputGroupDirectivesModule() {
    }
    return InputGroupDirectivesModule;
}());
exports.InputGroupDirectivesModule = __decorate([
    core.NgModule({
        imports: [],
        exports: [
            exports.InputGroupDirective,
            exports.InputGroupAddonDirective,
            exports.InputGroupBtnDirective,
        ],
        declarations: [
            exports.InputGroupDirective,
            exports.InputGroupAddonDirective,
            exports.InputGroupBtnDirective,
        ],
        providers: [],
    })
], exports.InputGroupDirectivesModule);

exports.ListGroupDirective = (function (_super) {
    __extends(ListGroupDirective, _super);
    function ListGroupDirective(r, er) {
        return _super.call(this, r, er, ['list-group'], ['UL']) || this;
    }
    return ListGroupDirective;
}(BootstrapDirective));
exports.ListGroupDirective = __decorate([
    core.Directive({ selector: '[upe-list-group]' }),
    __metadata("design:paramtypes", [typeof (_a$19 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$19 || Object, typeof (_b$19 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$19 || Object])
], exports.ListGroupDirective);
var _a$19;
var _b$19;

exports.ListGroupItemHeadingDirective = (function (_super) {
    __extends(ListGroupItemHeadingDirective, _super);
    function ListGroupItemHeadingDirective(r, er) {
        return _super.call(this, r, er, ['list-group-item-heading'], ['H1', 'H2', 'H3', 'H4', 'H5', 'H6']) || this;
    }
    return ListGroupItemHeadingDirective;
}(BootstrapDirective));
exports.ListGroupItemHeadingDirective = __decorate([
    core.Directive({ selector: '[upe-list-group-item-heading]' }),
    __metadata("design:paramtypes", [typeof (_a$20 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$20 || Object, typeof (_b$20 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$20 || Object])
], exports.ListGroupItemHeadingDirective);
var _a$20;
var _b$20;

exports.ListGroupItemTextDirective = (function (_super) {
    __extends(ListGroupItemTextDirective, _super);
    function ListGroupItemTextDirective(r, er) {
        return _super.call(this, r, er, ['list-group-item-text'], ['P']) || this;
    }
    return ListGroupItemTextDirective;
}(BootstrapDirective));
exports.ListGroupItemTextDirective = __decorate([
    core.Directive({ selector: '[upe-list-group-item-text]' }),
    __metadata("design:paramtypes", [typeof (_a$21 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$21 || Object, typeof (_b$21 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$21 || Object])
], exports.ListGroupItemTextDirective);
var _a$21;
var _b$21;

exports.ListGroupItemDirective = (function (_super) {
    __extends(ListGroupItemDirective, _super);
    function ListGroupItemDirective(r, er) {
        return _super.call(this, r, er, ['list-group-item'], ['LI']) || this;
    }
    return ListGroupItemDirective;
}(BootstrapTypeDirective));
__decorate([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.ListGroupItemDirective.prototype, "disabled", void 0);
exports.ListGroupItemDirective = __decorate([
    core.Directive({ selector: '[upe-list-group-item]' }),
    __metadata("design:paramtypes", [typeof (_a$22 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$22 || Object, typeof (_b$22 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$22 || Object])
], exports.ListGroupItemDirective);
ApplyMixins(exports.ListGroupItemDirective, [BootstrapDisabledDirective]);
var _a$22;
var _b$22;

exports.ListGroupDirectivesModule = (function () {
    function ListGroupDirectivesModule() {
    }
    return ListGroupDirectivesModule;
}());
exports.ListGroupDirectivesModule = __decorate([
    core.NgModule({
        imports: [],
        exports: [
            exports.ListGroupDirective,
            exports.ListGroupItemDirective,
            exports.ListGroupItemHeadingDirective,
            exports.ListGroupItemTextDirective,
        ],
        declarations: [
            exports.ListGroupDirective,
            exports.ListGroupItemDirective,
            exports.ListGroupItemHeadingDirective,
            exports.ListGroupItemTextDirective,
        ],
        providers: [],
    })
], exports.ListGroupDirectivesModule);

exports.PanelDirective = (function (_super) {
    __extends(PanelDirective, _super);
    function PanelDirective(r, er) {
        return _super.call(this, r, er, ['panel'], ['DIV'], 'default') || this;
    }
    return PanelDirective;
}(BootstrapTypeDirective));
exports.PanelDirective = __decorate([
    core.Directive({ selector: '[upe-panel]' }),
    __metadata("design:paramtypes", [typeof (_a$23 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$23 || Object, typeof (_b$23 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$23 || Object])
], exports.PanelDirective);
var _a$23;
var _b$23;

exports.PanelBodyDirective = (function (_super) {
    __extends(PanelBodyDirective, _super);
    function PanelBodyDirective(r, er) {
        return _super.call(this, r, er, ['panel-body']) || this;
    }
    return PanelBodyDirective;
}(BootstrapDirective));
exports.PanelBodyDirective = __decorate([
    core.Directive({ selector: '[upe-panel-body]' }),
    __metadata("design:paramtypes", [typeof (_a$24 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$24 || Object, typeof (_b$24 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$24 || Object])
], exports.PanelBodyDirective);
var _a$24;
var _b$24;

exports.PanelFooterDirective = (function (_super) {
    __extends(PanelFooterDirective, _super);
    function PanelFooterDirective(r, er) {
        return _super.call(this, r, er, ['panel-footer']) || this;
    }
    return PanelFooterDirective;
}(BootstrapDirective));
exports.PanelFooterDirective = __decorate([
    core.Directive({ selector: '[upe-panel-footer]' }),
    __metadata("design:paramtypes", [typeof (_a$25 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$25 || Object, typeof (_b$25 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$25 || Object])
], exports.PanelFooterDirective);
var _a$25;
var _b$25;

exports.PanelHeadingDirective = (function (_super) {
    __extends(PanelHeadingDirective, _super);
    function PanelHeadingDirective(r, er) {
        return _super.call(this, r, er, ['panel-heading']) || this;
    }
    return PanelHeadingDirective;
}(BootstrapDirective));
exports.PanelHeadingDirective = __decorate([
    core.Directive({ selector: '[upe-panel-heading]' }),
    __metadata("design:paramtypes", [typeof (_a$26 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$26 || Object, typeof (_b$26 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$26 || Object])
], exports.PanelHeadingDirective);
var _a$26;
var _b$26;

var BootstrapTextCenterDirective = (function (_super) {
    __extends(BootstrapTextCenterDirective, _super);
    function BootstrapTextCenterDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(BootstrapTextCenterDirective.prototype, "center", {
        set: function (value) {
            value ? this.addClass('text-center') : this.removeClass('text-center');
        },
        enumerable: true,
        configurable: true
    });
    return BootstrapTextCenterDirective;
}(BootstrapDirective));

exports.PanelTitleDirective = (function (_super) {
    __extends(PanelTitleDirective, _super);
    function PanelTitleDirective(r, er) {
        return _super.call(this, r, er, ['panel-title'], ['H1', 'H2', 'H3', 'H4', 'H5', 'H6']) || this;
    }
    return PanelTitleDirective;
}(BootstrapDirective));
__decorate([
    core.Input(),
    __metadata("design:type", Boolean)
], exports.PanelTitleDirective.prototype, "center", void 0);
exports.PanelTitleDirective = __decorate([
    core.Directive({ selector: '[upe-panel-title]' }),
    __metadata("design:paramtypes", [typeof (_a$27 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$27 || Object, typeof (_b$27 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$27 || Object])
], exports.PanelTitleDirective);
ApplyMixins(exports.PanelTitleDirective, [BootstrapTextCenterDirective]);
var _a$27;
var _b$27;

exports.PanelDirectivesModule = (function () {
    function PanelDirectivesModule() {
    }
    return PanelDirectivesModule;
}());
exports.PanelDirectivesModule = __decorate([
    core.NgModule({
        imports: [],
        exports: [
            exports.PanelDirective,
            exports.PanelHeadingDirective,
            exports.PanelTitleDirective,
            exports.PanelBodyDirective,
            exports.PanelFooterDirective,
        ],
        declarations: [
            exports.PanelDirective,
            exports.PanelHeadingDirective,
            exports.PanelTitleDirective,
            exports.PanelBodyDirective,
            exports.PanelFooterDirective,
        ],
        providers: [],
    })
], exports.PanelDirectivesModule);

exports.ProgressBarDirective = (function (_super) {
    __extends(ProgressBarDirective, _super);
    function ProgressBarDirective(r, er) {
        var _this = _super.call(this, r, er, ['progress-bar']) || this;
        _this.fraction = 2;
        _this._striped = false;
        _this._min = 0;
        _this._max = 100;
        _this._progress = 0;
        return _this;
    }
    Object.defineProperty(ProgressBarDirective.prototype, "progress", {
        set: function (value) {
            if (value < this._min || value > this._max) {
                throw new Error('out of boundary');
            }
            this._progress = value;
            var progress = this._progress.toFixed(this.fraction);
            this.setAttribute('aria-valuenow', progress);
            this.setStyle('width', progress + "%");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "min", {
        set: function (value) {
            this._min = value;
            this.setAttribute('aria-valuemin', this._min.toFixed(this.fraction));
            if (this._progress < this._min) {
                this.progress = this._min;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "max", {
        set: function (value) {
            this._max = value;
            this.setAttribute('aria-valuemax', this._max.toFixed(this.fraction));
            if (this._progress > this._max) {
                this.progress = this._max;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "minWidth", {
        set: function (value) {
            this.setStyle('min-width', typeof value === 'string' ? value : value + "px");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "striped", {
        set: function (value) {
            value ? this.addClass('progress-bar-striped') : this.removeClass('progress-bar-striped');
            this._striped = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "animated", {
        set: function (value) {
            var tmpStriped = this._striped;
            this.striped = value || this._striped;
            this._striped = tmpStriped;
            value ? this.addClass('active') : this.removeClass('active');
        },
        enumerable: true,
        configurable: true
    });
    ProgressBarDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.setAttribute('role', 'progressbar');
        this.progress = this._progress;
        this.min = this._min;
        this.max = this._max;
    };
    return ProgressBarDirective;
}(BootstrapTypeDirective));
__decorate([
    core.Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], exports.ProgressBarDirective.prototype, "progress", null);
__decorate([
    core.Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], exports.ProgressBarDirective.prototype, "min", null);
__decorate([
    core.Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], exports.ProgressBarDirective.prototype, "max", null);
__decorate([
    core.Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], exports.ProgressBarDirective.prototype, "minWidth", null);
__decorate([
    core.Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], exports.ProgressBarDirective.prototype, "striped", null);
__decorate([
    core.Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], exports.ProgressBarDirective.prototype, "animated", null);
__decorate([
    core.Input(),
    __metadata("design:type", Number)
], exports.ProgressBarDirective.prototype, "fraction", void 0);
exports.ProgressBarDirective = __decorate([
    core.Directive({ selector: '[upe-progress-bar]' }),
    __metadata("design:paramtypes", [typeof (_a$28 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$28 || Object, typeof (_b$28 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$28 || Object])
], exports.ProgressBarDirective);
var _a$28;
var _b$28;

exports.ProgressDirective = (function (_super) {
    __extends(ProgressDirective, _super);
    function ProgressDirective(r, er) {
        return _super.call(this, r, er, ['progress']) || this;
    }
    return ProgressDirective;
}(BootstrapDirective));
exports.ProgressDirective = __decorate([
    core.Directive({ selector: '[upe-progress]' }),
    __metadata("design:paramtypes", [typeof (_a$29 = typeof core.Renderer2 !== "undefined" && core.Renderer2) === "function" && _a$29 || Object, typeof (_b$29 = typeof core.ElementRef !== "undefined" && core.ElementRef) === "function" && _b$29 || Object])
], exports.ProgressDirective);
var _a$29;
var _b$29;

exports.ProgressBarDirectivesModule = (function () {
    function ProgressBarDirectivesModule() {
    }
    return ProgressBarDirectivesModule;
}());
exports.ProgressBarDirectivesModule = __decorate([
    core.NgModule({
        imports: [],
        exports: [
            exports.ProgressDirective,
            exports.ProgressBarDirective,
        ],
        declarations: [
            exports.ProgressDirective,
            exports.ProgressBarDirective,
        ],
        providers: [],
    })
], exports.ProgressBarDirectivesModule);

exports.NgxBootstrapDirectivesModule = (function () {
    function NgxBootstrapDirectivesModule() {
    }
    return NgxBootstrapDirectivesModule;
}());
exports.NgxBootstrapDirectivesModule = __decorate([
    core.NgModule({
        declarations: [],
        imports: [],
        providers: [],
        exports: [
            exports.BtnGroupDirectivesModule,
            exports.ButtonDirectivesModule,
            exports.InputGroupDirectivesModule,
            exports.ListGroupDirectivesModule,
            exports.PanelDirectivesModule,
            exports.ProgressBarDirectivesModule,
            exports.FormDirectivesModule,
        ],
    })
], exports.NgxBootstrapDirectivesModule);

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
