var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Directive, ElementRef, Input, Renderer2 } from '@angular/core';
import { BootstrapTypeDirective } from '../bootstrap/bootstrap-type.directive';
var ProgressBarDirective = (function (_super) {
    __extends(ProgressBarDirective, _super);
    function ProgressBarDirective(r, er) {
        var _this = _super.call(this, r, er, ['progress-bar']) || this;
        _this.fraction = 2;
        _this._striped = false;
        _this._min = 0;
        _this._max = 100;
        _this._progress = 0;
        return _this;
    }
    Object.defineProperty(ProgressBarDirective.prototype, "progress", {
        set: function (value) {
            if (value < this._min || value > this._max) {
                throw new Error('out of boundary');
            }
            this._progress = value;
            var progress = this._progress.toFixed(this.fraction);
            this.setAttribute('aria-valuenow', progress);
            this.setStyle('width', progress + "%");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "min", {
        set: function (value) {
            this._min = value;
            this.setAttribute('aria-valuemin', this._min.toFixed(this.fraction));
            if (this._progress < this._min) {
                this.progress = this._min;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "max", {
        set: function (value) {
            this._max = value;
            this.setAttribute('aria-valuemax', this._max.toFixed(this.fraction));
            if (this._progress > this._max) {
                this.progress = this._max;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "minWidth", {
        set: function (value) {
            this.setStyle('min-width', typeof value === 'string' ? value : value + "px");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "striped", {
        set: function (value) {
            value ? this.addClass('progress-bar-striped') : this.removeClass('progress-bar-striped');
            this._striped = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ProgressBarDirective.prototype, "animated", {
        set: function (value) {
            var tmpStriped = this._striped;
            this.striped = value || this._striped;
            this._striped = tmpStriped;
            value ? this.addClass('active') : this.removeClass('active');
        },
        enumerable: true,
        configurable: true
    });
    ProgressBarDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
        this.setAttribute('role', 'progressbar');
        this.progress = this._progress;
        this.min = this._min;
        this.max = this._max;
    };
    return ProgressBarDirective;
}(BootstrapTypeDirective));
export { ProgressBarDirective };
ProgressBarDirective.decorators = [
    { type: Directive, args: [{ selector: '[upe-progress-bar]' },] },
];
/** @nocollapse */
ProgressBarDirective.ctorParameters = function () { return [
    { type: Renderer2, },
    { type: ElementRef, },
]; };
ProgressBarDirective.propDecorators = {
    'progress': [{ type: Input },],
    'min': [{ type: Input },],
    'max': [{ type: Input },],
    'minWidth': [{ type: Input },],
    'striped': [{ type: Input },],
    'animated': [{ type: Input },],
    'fraction': [{ type: Input },],
};
//# sourceMappingURL=progress-bar.directive.js.map